import java.util.*;

/* Un API (con Valore Astratto e specifica) per cammini IMMUTABLE 
   presentata il 25/5/2016
*/

interface PathAPI {
    //Introduce Valori Astratti n1.n2.....0 per cammini IMMUTABLE in alberi o termini.
    //Un cammino \`e una sequenza di interi positivi terminante con 0 (per il cammino
    //vuoto). Ogni intero ni indica la posizione, nella lista dei figli, del sotto-
    //albero/termine da selezionare per il restante cammino.
    //Sia O un valore di tipo PathAPI allora Va(O)\in [PathAPI] \`e un cammino.
    public PathAPI add(int x);
        // se x<=0 restituisce this
        // se Va(this)=n1....nk.0 allora Va(this.add(x)= n1....nk.x.0
    public PathAPI addP(PathAPI p);
    // se Va(this)=n1....nk.0 e Va(p)=p1....ph.0 allora Va(this.addP(p)=n1....nk.p1....ph.0
    public boolean isEmpty();
        // true se Va(this)=0
    public int next() throws invalidOperationException;
    // Solleva invalidOperation se Va(this)=0
    // Calcola n1 se Va(this)=n1.p per p\in[PathAPI]
    public PathAPI rest() throws invalidOperationException;
    // Solleva invalidOperation se Va(this)=0
    // Calcola p se Va(this)=n1.p per p\in[PathAPI]
}
